"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class FlowArcProto(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    TAIL_FIELD_NUMBER: builtins.int
    HEAD_FIELD_NUMBER: builtins.int
    CAPACITY_FIELD_NUMBER: builtins.int
    UNIT_COST_FIELD_NUMBER: builtins.int
    tail: builtins.int
    """A directed arc goes from a tail node to a head node.
    Node ids must be non-negative (>= 0).
    """

    head: builtins.int
    capacity: builtins.int
    """Capacity of the arc. Must be non-negative (>= 0). If the capacity is zero,
    it is equivalent to not including the arc in the FlowModelProto.
    """

    unit_cost: builtins.int
    """Cost of this arc per unit of flow.
    Note that it can take any positive, negative or null value.
    """

    def __init__(self,
        *,
        tail: typing.Optional[builtins.int] = ...,
        head: typing.Optional[builtins.int] = ...,
        capacity: typing.Optional[builtins.int] = ...,
        unit_cost: typing.Optional[builtins.int] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["capacity",b"capacity","head",b"head","tail",b"tail","unit_cost",b"unit_cost"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["capacity",b"capacity","head",b"head","tail",b"tail","unit_cost",b"unit_cost"]) -> None: ...
global___FlowArcProto = FlowArcProto

class FlowNodeProto(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    SUPPLY_FIELD_NUMBER: builtins.int
    id: builtins.int
    """The ids must be non-negative (>= 0). They should be dense for good
    performance. Note that it is not mandatory to include nodes with no supply
    in a FlowModelProto.
    """

    supply: builtins.int
    """The supply can be positive or negative in which case it means demand.
    The sum of the supplies over all nodes must always be 0.
    """

    def __init__(self,
        *,
        id: typing.Optional[builtins.int] = ...,
        supply: typing.Optional[builtins.int] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["id",b"id","supply",b"supply"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id","supply",b"supply"]) -> None: ...
global___FlowNodeProto = FlowNodeProto

class FlowModelProto(google.protobuf.message.Message):
    """Holds a flow problem, see NodeProto and ArcProto for more details."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    class _ProblemType:
        ValueType = typing.NewType('ValueType', builtins.int)
        V: typing_extensions.TypeAlias = ValueType
    class _ProblemTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[FlowModelProto._ProblemType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        LINEAR_SUM_ASSIGNMENT: FlowModelProto._ProblemType.ValueType  # 0
        MAX_FLOW: FlowModelProto._ProblemType.ValueType  # 1
        MIN_COST_FLOW: FlowModelProto._ProblemType.ValueType  # 2
    class ProblemType(_ProblemType, metaclass=_ProblemTypeEnumTypeWrapper):
        """The type of problem to solve."""
        pass

    LINEAR_SUM_ASSIGNMENT: FlowModelProto.ProblemType.ValueType  # 0
    MAX_FLOW: FlowModelProto.ProblemType.ValueType  # 1
    MIN_COST_FLOW: FlowModelProto.ProblemType.ValueType  # 2

    NODES_FIELD_NUMBER: builtins.int
    ARCS_FIELD_NUMBER: builtins.int
    PROBLEM_TYPE_FIELD_NUMBER: builtins.int
    @property
    def nodes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___FlowNodeProto]: ...
    @property
    def arcs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___FlowArcProto]: ...
    problem_type: global___FlowModelProto.ProblemType.ValueType
    def __init__(self,
        *,
        nodes: typing.Optional[typing.Iterable[global___FlowNodeProto]] = ...,
        arcs: typing.Optional[typing.Iterable[global___FlowArcProto]] = ...,
        problem_type: typing.Optional[global___FlowModelProto.ProblemType.ValueType] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["problem_type",b"problem_type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["arcs",b"arcs","nodes",b"nodes","problem_type",b"problem_type"]) -> None: ...
global___FlowModelProto = FlowModelProto
